public class Antrieb
{
      private Serial seriell = null;
      //                       012345678901
      private byte[] puffer = "#+0000+0000$".getBytes();

      private PApplet pap;

      public Antrieb(PApplet pap)
      {
          this.pap = pap;
          try
          {
              seriell = new Serial(pap, "/dev/ttyACM0", 9600);
          }
          catch(Exception e)
          {
              println("Fehler in Klasse Antrieb: Arduino ist nicht verfügbar!");
          }
          setzeAntrieb(0, 0); //0...9999 nutzbar: 3300...4500
      }
      void setzeAntrieb(int links, int rechts)
      {
          if(links>9999)  links=9999;
          if(links<0)     links=0;
          if(rechts>9999) rechts=9999;
          if(rechts<0)    rechts=0;

          puffer[5] = (byte)(48+links%10);
          links/=10;
          puffer[4] = (byte)(48+links%10);
          links/=10;
          puffer[3] = (byte)(48+links%10);
          links/=10;
          puffer[2] = (byte)(48+links%10);
      
          puffer[10] = (byte)(48+rechts%10);
          rechts/=10;
          puffer[9] = (byte)(48+rechts%10);
          rechts/=10;
          puffer[8] = (byte)(48+rechts%10);
          rechts/=10;
          puffer[7] = (byte)(48+rechts%10);

          if(seriell!=null)
              seriell.write(puffer);              
      }
      
}
