
public class Kamera
{
      private PApplet pap;
      private int CAMBREITE,CAMHOEHE;
      private Capture cam;
      private int[] pix;

      private double SCHWELLE = 50000.0;
  
      public Kamera(PApplet pap,int CAMBREITE,int CAMHOEHE)
      {
          this.pap = pap;
          this.CAMBREITE = CAMBREITE;
          this.CAMHOEHE  = CAMHOEHE;
        
        
          String[] cameras = Capture.list();

          if (cameras == null) 
          {
              println("Failed to retrieve the list of available cameras, will try the default...");
              cam = new Capture(pap,CAMBREITE, CAMHOEHE);
          } 
          
          if (cameras.length == 0) 
          {
              println("There are no cameras available for capture.");
              exit();
          } 
          else 
          {
              println("Available cameras:");
              for (int i = 0; i < cameras.length; i++) 
              {
                  println(i+cameras[i]);
              }

              // The camera can be initialized directly using an element
              // from the array returned by list():
              cam = new Capture(pap, cameras[0]);
              // Or, the settings can be defined based on the text in the list
              //cam = new Capture(this, 640, 480, "Built-in iSight", 30);
    
              // Start capturing the images from the camera
              cam.start();
          }        
    }//Kamera()
      
    public void auffrischen()
    {
        if (cam!=null && cam.available() == true) 
        {
            cam.read();    
            cam.updatePixels();
            pix = cam.pixels;
        }
    }
    
    public void zeigeKamerabild(int x, int y)
    {
        if(cam!=null)
        {
            image(cam,x,y);
        }    
    }
    
    //Schwerpunkt des Rot-Anteils in X-Richtung
    public double bestimmeSchwerpunktRotX()
    {
      if(cam==null || pix==null)
      {
          return (double)CAMBREITE/2.0;          
      }
      else
      {
        double Si  = 0.0;
        
        int ii=0;
        double summe_echtes_rot = 0.0;

        for(int i=0;i<CAMHOEHE;i++)
        {

              for(int k=0;k<CAMBREITE;k++)
              {
                  int rot   = (int)red(pix[ii]);
                  int gruen = (int)green(pix[ii]);
                  int blau  = (int)blue(pix[ii]);

                  int echtes_rot = rot -blau -gruen;
                  if(echtes_rot<0)
                      echtes_rot =0;
                  echtes_rot *=7;
                  if(echtes_rot>255)
                      echtes_rot = 255;                  
                  
                  Si               += (double)k*(double)echtes_rot;
                  summe_echtes_rot += (double)echtes_rot;
                  
                  
                  ii++;
              }
        }       
        
        if(summe_echtes_rot>SCHWELLE)       
            return Si/summe_echtes_rot;
        else
            return (double)CAMBREITE/2.0;
      }//else cam==null  
    }
    
    //Schwerpunkt des Rot-Anteils in X-Richtung
    public double bestimmeSchwerpunktGruenY()
    {
      if(cam==null || pix==null)
      {
          return (double)CAMHOEHE/2.0;          
      }
      else
      {
        double Si  = 0.0;
        
        double summe_echtes_gruen = 0.0;

        for(int k=0;k<CAMBREITE;k++)
        {

              for(int i=0;i<CAMHOEHE;i++)
              {
                  int ii=i*CAMBREITE + k;                
                
                  int rot   = (int)red(pix[ii]);
                  int gruen = (int)green(pix[ii]);
                  int blau  = (int)blue(pix[ii]);

                  int echtes_gruen = gruen -blau -rot;
                  if(echtes_gruen<0)
                      echtes_gruen =0;
                  echtes_gruen *=7;
                  if(echtes_gruen>255)
                      echtes_gruen = 255;                  
                  
                  Si               += (double)i*(double)echtes_gruen;
                  summe_echtes_gruen += (double)echtes_gruen;                                    
              }
        }       
        
        if(summe_echtes_gruen>SCHWELLE)       
            return Si/summe_echtes_gruen;
        else
            return (double)CAMHOEHE/2.0;
      }//else cam==null  
    }    
}
