public class ModusA implements iModus
{
      private double t_alt;  //Zeit in Sekunden vom letzten Schritt
      private double t;      //Zeit in Sekunden beim aktuellen Schritt
      private double dt;     //Zeitdifferenz aktuell
      
      private double abweichung_alt;

      private double e_integ = 0.0;
      
      public ModusA()
      {
           abweichung_alt = 0.0;
           t_alt          = 0.001*(double)System.currentTimeMillis();
           t              = t_alt;
           dt             = 0.001;
      }
  
      public double berechneNeuenWert(double abweichung)
      {
          t          = 0.001*(double)System.currentTimeMillis();
          dt         = t - t_alt;
          double Kverstaerkung = 1.0;       
          double Ianteil       = 0.0;
          double stellgroesse = Kverstaerkung * abweichung + Ianteil*e_integ;                    

          t_alt = t; //z.B. für Integration 
          abweichung_alt = abweichung;
          
          e_integ += abweichung*dt;
          if(e_integ>800.0)
              e_integ = 800.0;
          if(e_integ<-800.0)
              e_integ = -800.0;
          
          return stellgroesse;        
      }
  
      public void perform()
      {
          kamera.auffrischen();
          //kamera.zeigeKamerabild(0,0); //Kamerabild ausschalten, sonst Reglung zu langsam  
          double Si = kamera.bestimmeSchwerpunktRotX();        
          double abweichung= (CAMBREITE/2) - Si;
          noStroke();
          stroke(255,0,0);
          line((float)Si+CAMBREITE,0,(float)Si+CAMBREITE,CAMHOEHE);
          
          //double Kverstaerkung = 1.25;          
          //double stellgroesse = Kverstaerkung * abweichung;
          
          double stellgroesse = this.berechneNeuenWert(abweichung);
          
          double OFFSET = 2725.0;
          double MAXWERT = 5000.0;
          
          //Totbereich des Motors berücksichtigen:
          
          
              
          //deckeln:
          if(stellgroesse>MAXWERT)
              stellgroesse = MAXWERT;
          if(stellgroesse<-MAXWERT)
              stellgroesse = -MAXWERT;
              
          
          int LINKS = 0;
          int RECHTS = 0;
          
          if(stellgroesse>0)
          {
                  LINKS = (int)(OFFSET);
                  RECHTS = (int)(OFFSET+stellgroesse);
          }
          else
          {
                  LINKS = (int)(OFFSET-stellgroesse);
                  RECHTS = (int)(OFFSET);
          }

          antrieb.setzeAntrieb(LINKS,RECHTS);
          
          text("Modus A: PI-Regler",100,CAMHOEHE+50);
          text("Abweichung: "+abweichung+" dt="+dt,100,CAMHOEHE+100);     
          text("Stellwert LINKS:"+LINKS+" RECHTS:"+RECHTS,100,CAMHOEHE+150);               
      }
}
